﻿using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class AverageActionsTaken : SimulatedPlaytraceMetric
    {
        int playthroughLength = 0;

        double avgPlaythroughLength;

        public AverageActionsTaken(IGraphStore store) : base(store)
        {
        }

        protected override void OnTreeEdge(InteractionEdge edge)
        {
            if (edge.Source.NodeType == InteractionNode.Type.InteractionPoint)
            {
                // This is an action if it was taken from an interaction point.
                playthroughLength++;
            }
        }

        protected override void OnStartPlaythrough(int playthroughNum)
        {
            playthroughLength = 0;
        }

        protected override void OnCompletePlaythrough(int playthroughNum)
        {
            AccumulateMetric(playthroughLength);
        }

        private void AccumulateMetric(double thisLength)
        {
            Result += thisLength / (double)NumPlaythroughs;
        }
    }
}
