﻿using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class AverageEdgesTraversed : SimulatedPlaytraceMetric
    {
        int playthroughLength = 0;

        double avgPlaythroughLength;

        public AverageEdgesTraversed(IGraphStore store) : base(store)
        {
        }

        protected override void OnTreeEdge(InteractionEdge edge)
        {
            playthroughLength++;
        }

        protected override void OnStartPlaythrough(int playthroughNum)
        {
            playthroughLength = 0;
        }

        protected override void OnCompletePlaythrough(int playthroughNum)
        {
            AccumulateMetric(playthroughLength);
        }

        private void AccumulateMetric(double thisLength)
        {
            Result += thisLength / (double)NumPlaythroughs;
        }
    }
}
