﻿using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class AverageNumInteractionPoints : InteractionMetric
    {
        public AverageNumInteractionPoints(IGraphStore store) : base(store)
        {
        }

        protected override void CalculateForGraph(InteractionMap graph)
        {
            int numInteractionPoints = 0;
            foreach (InteractionNode node in graph.Graph.Vertices)
            {
                if (node.NodeType == InteractionNode.Type.InteractionPoint)
                {
                    numInteractionPoints++;
                }
            }

            AccumulateMetric(numInteractionPoints);
        }
    }
}
