﻿using System;
using System.Collections.Generic;
using System.Linq;
using QuickGraph;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class AvgOutDegree : RatioScriptMetric
    {

        public AvgOutDegree(IGraphStore store) : base(store)
        {
        }

        protected override void CalculateForGraph(ScriptGraph graph)
        {
            double result = 0;
            foreach (ScriptNode node in graph.Graph.Vertices)
            {
                IEnumerable<IEdge<ScriptNode>> edges;
                if (graph.Graph.TryGetOutEdges(node, out edges))
                {
                    result += edges.Count();
                }
            }

            AccumulateRatioDenominator(graph.NumNodes);
            AccumulateMetric(result);
        }
    }
}
