﻿using System;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class ChoicesPerInteractionPoint : RatioInteractionMetric
    {
        public ChoicesPerInteractionPoint(IGraphStore store) : base(store)
        {
        }

        protected override void CalculateForGraph(InteractionMap graph)
        {
            int numChoices = 0;
            foreach (InteractionEdge edge in graph.Graph.Edges)
            {
                if (edge.EdgeType == InteractionEdge.Type.Choice)
                {
                    numChoices++;
                }
            }

            int numInteractionPoints = 0;
            foreach (InteractionNode node in graph.Graph.Vertices)
            {
                if (node.NodeType == InteractionNode.Type.InteractionPoint)
                {
                    numInteractionPoints++;
                }
            }

            AccumulateRatioDenominator(numInteractionPoints);
            AccumulateMetric(numChoices);
        }
    }
}
