﻿using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class FeedbackEventRatio : RatioInteractionMetric
    {
        public FeedbackEventRatio(IGraphStore store) : base(store)
        {
        }

        protected override void CalculateForGraph(InteractionMap graph)
        {
            int numFeedback = 0;
            int numEvents = 0;

            foreach (InteractionNode node in graph.Graph.Vertices)
            {
                if (node.NodeType == InteractionNode.Type.Feedback)
                {
                    numFeedback++;
                }
                else if (node.NodeType == InteractionNode.Type.Event)
                {
                    numEvents++;
                }
            }

            AccumulateRatioDenominator(numEvents);
            AccumulateMetric(numFeedback);
        }
    }
}
