﻿using System.Collections.Generic;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class FeedbackPerInteraction : RatioInteractionMetric
    {
        public FeedbackPerInteraction(IGraphStore store) : base(store)
        {
        }

        protected override void CalculateForGraph(InteractionMap graph)
        {
            int numFeedback = 0;
            HashSet<string> interactionUnits = new HashSet<string>();
            foreach (InteractionNode node in graph.Graph.Vertices)
            {
                if (node.NodeType == InteractionNode.Type.Feedback)
                {
                    numFeedback++;
                }

                interactionUnits.UnionWith(node.InteractionUnits);
            }

            int numInteractionUnits = interactionUnits.Count;

            AccumulateRatioDenominator(numInteractionUnits);

            AccumulateMetric(numFeedback);
        }
    }
}
