﻿using System.Collections.Generic;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.Metrics
{
    public class GlobalDiversity : SimulatedPlaytraceMetric
    {
        private HashSet<InteractionEdge> visitedActions = new HashSet<InteractionEdge>();

        protected override double Result
        {
            get
            {
                return visitedActions.Count;
            }
        }

        public GlobalDiversity(IGraphStore store) : base(store)
        {
        }

        protected override void OnTreeEdge(InteractionEdge edge)
        {
            if (edge.Source.NodeType == InteractionNode.Type.InteractionPoint)
            {
                visitedActions.Add(edge);
            }
        }
    }
}
