﻿using System;
using System.Collections.Generic;

namespace StudyCrafter.Assistant.Representation
{
    public class BinaryOperator : IOperator
    {
        private IOperand left;
        private IOperand right;

        private OpType type;

        public BinaryOperator(IOperand left, OpType type, IOperand right)
        {
            this.left = left;
            this.right = right;
            this.type = type;
        }

        public OpType Type
        {
            get
            {
                return type;
            }
        }

        public IEnumerable<IOperand> Operands
        {
            get
            {
                yield return left;
                yield return right;
            }
        }
    }
}
