﻿
using System.Collections.Generic;
using QuickGraph;

namespace StudyCrafter.Assistant.Representation
{
    public class GraphCollection<TVertex, TEdge> where TEdge : IEdge<TVertex>
    {
        IDictionary<GraphID, IGraphOwner<TVertex, TEdge>> graphs;

        public GraphCollection()
        {
            graphs = new Dictionary<GraphID, IGraphOwner<TVertex, TEdge>>();
        }

        public bool AddOwner(IGraphOwner<TVertex, TEdge> graphOwner)
        {
            if (Contains(graphOwner.ID))
            {
                return false;
            }
            graphs.Add(graphOwner.ID, graphOwner);
            return true;
        }

        public bool TryGetOwner(GraphID id, out IGraphOwner<TVertex, TEdge> graphOwner)
        {
            return graphs.TryGetValue(id, out graphOwner);
        }

        public bool RemoveOwner(GraphID id)
        {
            return graphs.Remove(id);
        }

        public bool Contains(GraphID id)
        {
            return graphs.ContainsKey(id);
        }

    }
}
