﻿
using QuickGraph;

namespace StudyCrafter.Assistant.Representation
{
    public interface IGraphStore
    {
        bool AddOwner<TVertex, TEdge>(IGraphOwner<TVertex, TEdge> graphOwner) where TEdge : IEdge<TVertex> where TVertex : IGraphNode;

        bool RemoveOwner<TVertex, TEdge>(GraphID id) where TEdge : IEdge<TVertex> where TVertex : IGraphNode;

        bool TryGetOwner<TVertex, TEdge>(GraphID id, out IGraphOwner<TVertex, TEdge> graphOwner) where TEdge : IEdge<TVertex> where TVertex : IGraphNode;
    }
}
