﻿
using System.Collections.Generic;

namespace StudyCrafter.Assistant.Representation
{
    public interface IPropertyDictionary
    {
        IProperty Get(string name);

        bool TryGet(string name, out IProperty property);

        void Set(IProperty val);

        bool Remove(string name);

        T Get<T>(string name) where T : IProperty;

        bool TryGet<T>(string name, out T property);

        void Set<T>(T val) where T : IProperty;

        bool Remove<T>(string name) where T : IProperty;

        bool Contains(string name);

        IEnumerable<IProperty> All();

        void AddAll(IPropertyDictionary properties);
    }
}
