﻿
using QuickGraph;

namespace StudyCrafter.Assistant.Representation
{
	public class SequentialEdgeIDGenerator<TVertex, TEdge> : IEdgeIDGenerator<TVertex, TEdge> where TEdge : IEdge<TVertex>
	{
		private int nextID = 0;

		public SequentialEdgeIDGenerator()
		{
		}

		public SequentialEdgeIDGenerator(int startID)
		{
			nextID = startID;
		}

		public int GenerateID(TEdge edge)
		{
			return ++nextID;
		}
	}
}