﻿using System;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.StudyCrafterLoading
{
    public class InteractionMapMetaGraphBuilder : IGraphBuilder<InteractionMap, InteractionNode, InteractionEdge>
    {
        ScriptGraph scriptGraph;
        StudyCrafterLoadHelpers loadHelpers;

        public InteractionMapMetaGraphBuilder(ScriptGraph scriptGraph, StudyCrafterLoadHelpers loadHelpers)
        {
            this.scriptGraph = scriptGraph;
            this.loadHelpers = loadHelpers;
        }

        public InteractionMap Build()
        {
            InteractionMap interactionMap = new InteractionMap();
            GraphID id = loadHelpers.IDGenerator.GenerateID(interactionMap);

            interactionMap.SetID(id);

            loadHelpers.GraphStore.AddOwner(interactionMap);

            ScriptToInteractionMapAlgorithm interactionMapBuildingAlg = new ScriptToInteractionMapAlgorithm(interactionMap, this.scriptGraph);
            interactionMapBuildingAlg.Compute();
            // TODO: re-work this function to be async

            return interactionMap;
        }
    }
}
