﻿using QuickGraph;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.StudyCrafterLoading
{
    public class JSonLayoutGraphBuilder : IGraphBuilder<LayoutGraph, LayoutNode, LayoutGraph.Edge>
    {
        private LayoutSerializationData layoutData;

        private StudyCrafterLoadHelpers loadHelpers;

        public JSonLayoutGraphBuilder(LayoutSerializationData data, StudyCrafterLoadHelpers loadHelpers)
        {
            layoutData = data;
            this.loadHelpers = loadHelpers;
        }

        public LayoutGraph Build()
        {
            LayoutGraph resultGraph = new LayoutGraph()
                                        .FromSerializationData(layoutData, loadHelpers);

            resultGraph.SetID(loadHelpers.IDGenerator.GenerateID(resultGraph));

            loadHelpers.GraphStore.AddOwner(resultGraph);

            return resultGraph;
        }
    }
}
