﻿using QuickGraph;
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.StudyCrafterLoading
{
    public class JSonScriptGraphBuilder : IGraphBuilder<ScriptGraph, ScriptNode, IEdge<ScriptNode>>
    {
        private ScriptSerializationData scriptData;

        private StudyCrafterLoadHelpers loadHelpers;

        public JSonScriptGraphBuilder(ScriptSerializationData data, StudyCrafterLoadHelpers loadHelpers)
        {
            scriptData = data;
            this.loadHelpers = loadHelpers;
        }

        public ScriptGraph Build()
        {
            ScriptGraph scriptGraph = new ScriptGraph()
                    .FromSerializationData(scriptData, loadHelpers.ScriptNodeDefs);

            scriptGraph.SetID(loadHelpers.IDGenerator.GenerateID(scriptGraph));

            loadHelpers.GraphStore.AddOwner(scriptGraph);

            return scriptGraph;
        }
    }
}