﻿using StudyCrafter.Assistant.StudyCrafterScenario;

namespace StudyCrafter.Assistant.StudyCrafterLoading
{
    public static class LayoutGraphJsonLoadingExtensions
    {
        public static LayoutGraph FromSerializationData(this LayoutGraph graph, LayoutSerializationData layoutData, StudyCrafterLoadHelpers loadHelpers)
        {
            graph.UID = layoutData.ID;
            graph.Name = layoutData.Name;
            graph.Title = layoutData.Title;
            graph.Position = layoutData.Position;
            graph.Background = layoutData.Background;

            return graph.AddSerializedNodes(layoutData, loadHelpers);
        }

        public static LayoutGraph AddSerializedNodes(this LayoutGraph graph, LayoutSerializationData layoutData, StudyCrafterLoadHelpers loadHelpers)
        {
            foreach (LayoutNodeSerializationData nodeData in layoutData.LayoutObjects)
            {
                LayoutNode node = new LayoutNode()
                                            .FromSerializationData(nodeData, loadHelpers);

                // Hold off on updating edges, since we'll do that work later.
                graph.AddNode(node, updateEdges: false);
            }

            graph.UpdateAllEdges();

            return graph;
        }
    }
}
