﻿using Newtonsoft.Json;
using StudyCrafter.Assistant.StudyCrafterTypes;
using UnityEngine;

namespace StudyCrafter.Assistant.StudyCrafterLoading
{
	public class LayoutNodeSerializationData
	{
		[JsonProperty("name")]
		public string Name { get; private set; }

		[JsonProperty("uid")]
		public int ID { get; private set; }

		[JsonProperty("pos")]
		public Vector3 Position { get; private set; }

		[JsonProperty("size")]
		public Vector2 Size { get; private set; }

		[JsonProperty("rotation")]
		public float Rotation { get; private set; }

		[JsonProperty("visible")]
		public bool Visible { get; private set; }

		[JsonProperty("locked")]
		public bool Locked { get; private set; }

		[JsonProperty("color")]
		public string Color { get; private set; }

		[JsonProperty("textcolor")]
		public string TextColor { get; private set; }

		[JsonProperty("image")]
		public string Image { get; private set; }

		[JsonProperty("value")]
		public float Value { get; private set; }

		[JsonProperty("text")]
		public string Text { get; private set; }

		[JsonProperty("fontSize")]
		public int FontSize { get; private set; }

		[JsonProperty("parentName")]
		public string ParentName { get; private set; }

		[JsonProperty("objectType")]
		[JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
		public ObjectControl.ObjectType ObjectType { get; private set; }
	}
}