﻿using System.Collections;
using System.Collections.Generic;

namespace StudyCrafter.Assistant.StudyCrafterLoading
{
    public class ScriptSerializationData : IDictionary<string, ScriptNodeSerializationData>
    {
        private IDictionary<string, ScriptNodeSerializationData> nodes;

        public ScriptSerializationData()
        {
            nodes = new Dictionary<string, ScriptNodeSerializationData>();
        }

        public ScriptNodeSerializationData this[string key] { get { return nodes[key]; } set { nodes[key] = value; } }

        public ICollection<string> Keys { get { return nodes.Keys; } }

        public ICollection<ScriptNodeSerializationData> Values { get { return nodes.Values; } }

        public int Count { get { return nodes.Count; } }

        public bool IsReadOnly { get { return nodes.IsReadOnly; } }

        public void Add(string key, ScriptNodeSerializationData value)
        {
            nodes.Add(key, value);
        }

        public void Add(KeyValuePair<string, ScriptNodeSerializationData> item)
        {
            nodes.Add(item);
        }

        public void Clear()
        {
            nodes.Clear();
        }

        public bool Contains(KeyValuePair<string, ScriptNodeSerializationData> item)
        {
            return nodes.Contains(item);
        }

        public bool ContainsKey(string key)
        {
            return nodes.ContainsKey(key);
        }

        public void CopyTo(KeyValuePair<string, ScriptNodeSerializationData>[] array, int arrayIndex)
        {
            nodes.CopyTo(array, arrayIndex);
        }

        public IEnumerator<KeyValuePair<string, ScriptNodeSerializationData>> GetEnumerator()
        {
            return nodes.GetEnumerator();
        }

        public bool Remove(string key)
        {
            return nodes.Remove(key);
        }

        public bool Remove(KeyValuePair<string, ScriptNodeSerializationData> item)
        {
            return nodes.Remove(item);
        }

        public bool TryGetValue(string key, out ScriptNodeSerializationData value)
        {
            return nodes.TryGetValue(key, out value);
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return nodes.GetEnumerator();
        }
    }
}