﻿
using StudyCrafter.Assistant.Representation;
using StudyCrafter.Assistant.StudyCrafterTypes;
using UnityEngine;

namespace StudyCrafter.Assistant.StudyCrafterScenario
{
	public class LayoutNode : BaseGraphNode
	{
		public string Color
		{
			get
			{
				return Properties.Get<StringProperty>("color").Val;
			}
			set
			{
				Properties.Set(new StringProperty("color", value));
			}
		}

		public int FontSize
		{
			get
			{
				return Properties.Get<IntProperty>("fontSize").IntValue;
			}
			set
			{
				Properties.Set(new IntProperty("fontSize", value));
			}
		}

		public string Image
		{
			get
			{
				return Properties.Get<StringProperty>("image").Val;
			}
			set
			{
				Properties.Set(new StringProperty("image", value));
			}
		}

		public bool Locked
		{
			get
			{
				return Properties.Get<BoolProperty>("locked").BoolValue;
			}
			set
			{
				Properties.Set(new BoolProperty("locked", value));
			}
		}

		public string Name
		{
			get
			{
				return Properties.Get<StringProperty>("name").Val;
			}
			set
			{
				Properties.Set(new StringProperty("name", value));
			}
		}

		public ObjectControl.ObjectType ObjectType
		{
			get
			{
				return (ObjectControl.ObjectType)(Properties.Get<IntProperty>("objectType").IntValue);
			}
			set
			{
				Properties.Set(new IntProperty("objectType", (int)value));
			}
		}

		public string ParentName
		{
			get
			{
				return Properties.Get<StringProperty>("parentName").Val;
			}
			set
			{
				Properties.Set(new StringProperty("parentName", value));
			}
		}

		public Vector3 Position { get; set; }

		public double Rotation
		{
			get
			{
				return Properties.Get<DoubleProperty>("rotation").DoubleValue;
			}
			set
			{
				Properties.Set(new DoubleProperty("rotation", value));
			}
		}

		public Vector2 Size { get; set; }

		public string Text
		{
			get
			{
				return Properties.Get<StringProperty>("text").Val;
			}
			set
			{
				Properties.Set(new StringProperty("text", value));
			}
		}

		public string TextColor
		{
			get
			{
				return Properties.Get<StringProperty>("textcolor").Val;
			}
			set
			{
				Properties.Set(new StringProperty("textcolor", value));
			}
		}

		public double Value
		{
			get
			{
				return Properties.Get<DoubleProperty>("value").DoubleValue;
			}
			set
			{
				Properties.Set(new DoubleProperty("value", value));
			}
		}

		public bool Visible
		{
			get
			{
				return Properties.Get<BoolProperty>("visible").BoolValue;
			}
			set
			{
				Properties.Set(new BoolProperty("visible", value));
			}
		}

		public LayoutNode()
		{
		}

		public LayoutNode(string id) : base(id)
		{
		}
	}
}
